﻿using System;
using System.Drawing;
using System.Threading;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// DX 헬퍼
        /// </summary>
        private DXHelper dxHelper;

        /// <summary>
        /// 비트맵
        /// </summary>
        private Bitmap bitmap = null;

        /// <summary>
        /// 그래픽스
        /// </summary>
        private Graphics graphics = null;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.dxHelper = new DXHelper();

            this.dxHelper.InitializePictureBox(this.pictureBox);

            this.graphics = this.pictureBox.CreateGraphics();

            FormClosing += Form_FormClosing;
            Load        += Form_Load;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 폼 로드시 처리하기 - Form_Load(sender, e)

        /// <summary>
        /// 폼 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Form_Load(object sender, EventArgs e)
        {
            this.dxHelper.LoadBitmap("IMAGE\\sample.png");

            Thread thread = new Thread(ProcessRender);

            thread.Start();
        }

        #endregion
        #region 폼을 닫을 경우 처리하기 - Form_FormClosing(sender, e)

        /// <summary>
        /// 폼을 닫을 경우 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Form_FormClosing(object sender, FormClosingEventArgs e)
        {
            this.dxHelper?.Dispose();

            this.dxHelper = null;

            this.bitmap?.Dispose();

            this.bitmap = null;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Event

        #region 렌더링 처리하기 - ProcessRender()

        /// <summary>
        /// 렌더링 처리하기
        /// </summary>
        private void ProcessRender()
        {
            Thread.Sleep(30);

            this.dxHelper.Render();
        }

        #endregion
    }
}